#ifndef FILE_SYSTEM_H
#define FILE_SYSTEM_H

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include <string>
using namespace std;


class FileSystem{

public:
	static bool FileExists(const string & path);
	
	static bool DirectoryExists(const string & path);

	static int CompareFileTimestamps(const string & path1, const string & path2);

	static bool Test(ostream & os);

private:
	static bool ReadFileInfo(const string & path, struct stat * info);
	
	static string FileDoesNotExistErrorMessage(const string & path);
};


#endif
