
#ifndef HTTP_INPUT_STREAM_H
#define HTTP_INPUT_STREAM_H

#include "InputStream.h"

#include <string>
using namespace std;


class HTTPInputStream : public InputStream {
public:
  HTTPInputStream(const string & url);
  ~HTTPInputStream();

  bool IsOpen();
  bool IsDone();
  char Read();
  void Close();

private:
  string host;
  int port;
  string path;
  int sockfd;
  int contentLength;
  string location;
  int numRead;
  bool done;
  char nextByte;

  void Init();
  void ParseURL(const string & url);
  void OpenConnection();
  void SendRequest();
  void ParseHTTPStatusLine(int & statusCode, string & reasonPhrase);
  void ParseHTTPHeaders();
  void ParseContentLength(const string & line);
  void ParseLocation(const string & line);
  void ReadHeaderLine(string & line);
  void ReadByte();
  bool IsSuccessfulResponse(int statusCode);
  bool IsRedirectResponse(int statusCode);
  void DumpResponse();
	  		
};


#endif
