#include "CommandRunner.h"
#include "CS240Exception.h"
#include "StringUtil.h"

#include <stdlib.h>
#include <sstream>
using namespace std;


void CommandRunner::Run(const string & commandText) {

	string commandTextCopy = commandText;
	StringUtil::Trim(commandTextCopy);
	
	if (commandTextCopy == "") {
		throw CS240Exception(InvalidCommandErrorMessage(commandTextCopy));
	}

	if (::system(commandTextCopy.c_str()) != 0) {
		throw CS240Exception(CommandFailedErrorMessage(commandTextCopy));
	}
}


string CommandRunner::InvalidCommandErrorMessage(const string & commandText) {
	ostringstream message;
	message << "invalid command: " << commandText;
	return message.str();
}


string CommandRunner::CommandFailedErrorMessage(const string & commandText) {
	ostringstream message;
	message << "command failed: " << commandText;
	return message.str();
}



