
#include "StringUtil.h"
#include <ctype.h>


bool StringUtil::IsPrefix(const string & str, const string & prefix) {
#if (__GNUC__ > 2)
  return (str.length() >= prefix.length() &&
	  str.compare(0, prefix.length(), prefix) == 0);
#else
  return (str.length() >= prefix.length() &&
	  str.compare(prefix, 0, prefix.length()) == 0);
#endif
}


bool StringUtil::IsSuffix(const string & str, const string & suffix) {
#if (__GNUC__ > 2)
  return (str.length() >= suffix.length() &&
	  str.compare(str.length() - suffix.length(), suffix.length(), suffix) == 0);
#else
  return (str.length() >= suffix.length() &&
	  str.compare(suffix, str.length() - suffix.length(), suffix.length()) == 0);
#endif
}


void StringUtil::ToLower(string & str) {
  string::iterator p = str.begin();
  while (p != str.end()) {
    *p = tolower(*p);
    ++p;
  }
}


void StringUtil::Trim(string & str) {

	if (str.length() == 0) {
		return;
	}
	
	int count = 0;
	string::size_type pos = 0;

	while (pos < str.length() && isspace(str[pos])) {
		++count;
		++pos;
	}
	
	if (count > 0) {
		str.erase(0, count);
	}
	
	if (str.length() == 0) {
		return;
	}
	
	count = 0;
	pos = str.length() - 1;

	while (isspace(str[pos])) {
		++count;
		if (pos == 0) {
			break;
		}
		else {
			--pos;
		}
	}

	if (count > 0) {
		str.erase(str.length() - count);
	}
}

